/* @clake/react-bootstrap4-window v0.2.8 | by Clake
 * Copyright (c) 2020 Clake,
 * 2020-01-10T10:10:58+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 拖动控制类
 * @author clake
 * @version 0.1
 */
var move = {
  x: 0,
  y: 0
};

var Drag =
/*#__PURE__*/
function () {
  /**
   * 初始化方法
   * @param dragDom  DOMElement|string   拖动对像,可以传入DOM对像或selector字符串
   * @param eventDom DOMElement|string   拖动事件对像,可以传入DOM对像或selector字符串
   * @param events   object              事件对像,可选多个事件
   */
  function Drag(dragDom, eventDom, events) {
    var _this = this;

    _classCallCheck(this, Drag);

    _defineProperty(this, "beginDrag", function (e) {
      if (e.button !== 0) {
        return false;
      }

      _this.eventDom = e.currentTarget; // e.preventDefault();

      window.addEventListener('mousemove', _this.startMove, false);
    });

    _defineProperty(this, "startMove", function (e) {
      if (e.buttons !== 1) {
        window.removeEventListener('mousemove', _this.startMove, false);
        return false;
      }

      window.removeEventListener('mousemove', _this.startMove, false);

      if (!_this._evtStart(_this.dragDom, _this.eventDom, e)) {
        return false;
      }

      _this.domX = parseInt(_this.dragDom.style.left);
      _this.domY = parseInt(_this.dragDom.style.top);
      _this.dragX = parseInt(e.pageX);
      _this.dragY = parseInt(e.pageY);
      window.addEventListener('mousemove', _this.moveDrag, false);
      window.addEventListener('mouseup', _this.overDrag, false);
    });

    _defineProperty(this, "moveDrag", function (e) {
      move.x = _this.domX + (parseInt(e.pageX) - _this.dragX);
      move.y = _this.domY + (parseInt(e.pageY) - _this.dragY);

      if (typeof _this._evtMove === "function") {
        _this._evtMove(move, _this.dragDom, _this.eventDom, e);
      }

      _this.dragDom.style.top = move.y + 'px';
      _this.dragDom.style.left = move.x + 'px';
    });

    _defineProperty(this, "overDrag", function (e) {
      window.removeEventListener('mousemove', _this.moveDrag);
      window.removeEventListener('mouseup', _this.overDrag);

      _this._evtEnd(_this.dragDom, _this.eventDom, e);
    });

    this.dragX = 0;
    this.dragY = 0;
    this.domX = 0;
    this.domY = 0;
    this.x = 0;
    this.y = 0;
    this.setDragDom(dragDom);
    this.setEventDom(eventDom);
    this.initEvents(events || {});
  }

  _createClass(Drag, [{
    key: "setDragDom",
    value: function setDragDom(dragDom) {
      if (dragDom instanceof HTMLElement) {
        this.dragDom = dragDom;
      } else if (typeof dragDom === "string") {
        this.dragDom = document.querySelector(dragDom);
      } else {
        throw "dragDom must be selector string or HTMLElement object";
      }
    }
  }, {
    key: "setEventDom",
    value: function setEventDom(eventDom) {
      if (eventDom instanceof HTMLElement) {
        this.eventDom = eventDom;
      } else if (typeof eventDom === 'string') {
        this.eventDom = document.querySelector(eventDom);
      } else {
        this.eventDom = this.dragDom;
      }

      this.bindEvents();
    }
  }, {
    key: "initEvents",
    value: function initEvents(events) {
      this._evtStart = events.start || defaultEvent;
      this._evtMove = events.move || null;
      this._evtEnd = events.end || defaultEvent;
    }
  }, {
    key: "bindEvents",
    value: function bindEvents() {
      this.eventDom.addEventListener("mousedown", this.beginDrag, false);
    }
  }, {
    key: "unbind",
    value: function unbind() {
      this.eventDom.removeEventListener('mousedown', this.beginDrag);
    }
  }]);

  return Drag;
}();

exports["default"] = Drag;

function defaultEvent() {
  return true;
}
//# sourceMappingURL=Drag.js.map
